### Eclipse Workspace Patch 1.0
#P org.jboss.tools.deltacloud.core
Index: src/org/jboss/tools/internal/deltacloud/core/observable/ObservablePojo.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/core/observable/ObservablePojo.java	(revision 29743)
+++ src/org/jboss/tools/internal/deltacloud/core/observable/ObservablePojo.java	(working copy)
@@ -34,11 +34,15 @@
     }
 	
 	public void addPropertyChangeListener(String propertyName, PropertyChangeListener listener) {
-		propertyChangeSupport.addPropertyChangeListener(propertyName, listener);
+		if (!contains(listener)) {
+			propertyChangeSupport.addPropertyChangeListener(propertyName, listener);
+		}
 	}
 
 	public void addPropertyChangeListener(PropertyChangeListener listener) {
-		propertyChangeSupport.addPropertyChangeListener(listener);
+		if (!contains(listener)) {
+			propertyChangeSupport.addPropertyChangeListener(listener);
+		}
 	}
 
 	public void removePropertyChangeListener(String propertyName, PropertyChangeListener listener) {
@@ -50,6 +54,17 @@
 		propertyChangeSupport.removePropertyChangeListener(listener);
 	}
 	
+    protected boolean contains(PropertyChangeListener listener) {
+    	boolean contains = false;
+    	for (PropertyChangeListener registeredListener : propertyChangeSupport.getPropertyChangeListeners()) {
+    		if (registeredListener == listener) {
+    			contains = true;
+    			break;
+    		}
+    	}
+    	return contains;
+    }
+    
 	protected PropertyChangeSupport getPropertyChangeSupport() {
 		return propertyChangeSupport;
 	}
#P org.jboss.tools.deltacloud.ui
Index: src/org/jboss/tools/deltacloud/ui/views/cloud/property/CVPropertySheetPage.java
===================================================================
--- src/org/jboss/tools/deltacloud/ui/views/cloud/property/CVPropertySheetPage.java	(revision 29744)
+++ src/org/jboss/tools/deltacloud/ui/views/cloud/property/CVPropertySheetPage.java	(working copy)
@@ -74,4 +74,8 @@
 		}
 	}
 
+	@Override
+	public void dispose() {
+		removePropertyChangeListener(deltaCloud);
+	}
 }
Index: src/org/jboss/tools/deltacloud/ui/views/cloudelements/ImageView.java
===================================================================
--- src/org/jboss/tools/deltacloud/ui/views/cloudelements/ImageView.java	(revision 29819)
+++ src/org/jboss/tools/deltacloud/ui/views/cloudelements/ImageView.java	(working copy)
@@ -10,8 +10,6 @@
  *******************************************************************************/
 package org.jboss.tools.deltacloud.ui.views.cloudelements;
 
-import java.beans.PropertyChangeEvent;
-
 import org.jboss.tools.deltacloud.core.DeltaCloud;
 import org.jboss.tools.deltacloud.core.DeltaCloudImage;
 import org.jboss.tools.deltacloud.core.ICloudElementFilter;
@@ -48,14 +46,6 @@
 	}
 
 	@Override
-	public void propertyChange(PropertyChangeEvent event) {
-		super.propertyChange(event);
-		if (DeltaCloud.PROP_IMAGES.equals(event.getPropertyName())) {
-			updateFilteredLabel();
-		}
-	}
-
-	@Override
 	protected ICloudElementFilter<DeltaCloudImage> getFilter(DeltaCloud cloud) {
 		return cloud.getImageFilter();
 	}
Index: src/org/jboss/tools/deltacloud/ui/views/cloudelements/AbstractCloudElementTableView.java
===================================================================
--- src/org/jboss/tools/deltacloud/ui/views/cloudelements/AbstractCloudElementTableView.java	(revision 29819)
+++ src/org/jboss/tools/deltacloud/ui/views/cloudelements/AbstractCloudElementTableView.java	(working copy)
@@ -431,7 +431,7 @@
 
 	protected void addPropertyChangeListener(DeltaCloud cloud) {
 		if (cloud != null) {
-			cloud.addPropertyChangeListener(DeltaCloud.PROP_NAME, this);
+			cloud.addPropertyChangeListener(this);
 		}
 	}
 
@@ -469,6 +469,7 @@
 
 	@Override
 	public void dispose() {
+		removePropertyChangeListener(currentCloud);
 		getSite().getWorkbenchWindow().getSelectionService().removePostSelectionListener(workbenchSelectionListener);
 		DeltaCloudManager.getDefault().removeCloudManagerListener(this);
 		super.dispose();
Index: src/org/jboss/tools/deltacloud/ui/views/cloudelements/InstanceView.java
===================================================================
--- src/org/jboss/tools/deltacloud/ui/views/cloudelements/InstanceView.java	(revision 29819)
+++ src/org/jboss/tools/deltacloud/ui/views/cloudelements/InstanceView.java	(working copy)
@@ -52,14 +52,6 @@
 		evaluationService.requestEvaluation("org.jboss.tools.deltacloud.ui.commands.canReboot");
 		evaluationService.requestEvaluation("org.jboss.tools.deltacloud.ui.commands.canDestroy");
 	}
-
-	@Override
-	protected void addPropertyChangeListener(DeltaCloud cloud) {
-		if (cloud != null) {
-			super.addPropertyChangeListener(cloud);
-			cloud.addPropertyChangeListener(DeltaCloud.PROP_INSTANCES, this);
-		}
-	}
 	
 	@Override
 	public void propertyChange(PropertyChangeEvent event) {
@@ -73,5 +65,4 @@
 	protected ICloudElementFilter<DeltaCloudInstance> getFilter(DeltaCloud cloud) {
 		return cloud.getInstanceFilter();
 	}
-
 }